
QGIS Application - Bug report #13754

Selected Multipolygon  by Rectangle / "on the fly" reprojection = Only few entities are selected

2015-11-04 06:02 AM - Julien Ancelin

Status: Closed

Priority: Severe/Regression

Assignee:

Category: Map Canvas

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 21781

Description

Hi,

The graphical selection on multipolygons, does not recover all entities when using reprojection "on the fly".

example:

multipolygon CRS 3857 + qgis project CRS 3857 + selection of all entities: works well

multipolygon CRS 3857 + qgis project CRS 2154 ("on the fly" reprojection) + selection of all entities: Only few entities are selected

Associated revisions

Revision 0a83f182 - 2016-06-22 03:22 PM - Jürgen Fischer

selection by polygon: use 40 instead of 4 points for selection rectangle for more accurate transformation (fixes #13754)

Revision a7dcaad8 - 2016-06-27 12:40 AM - Jürgen Fischer

selection by polygon: use 40 instead of 4 points for selection rectangle for more accurate transformation (fixes #13754)

(cherry picked from commit 0a83f182f3e8aea684163096f70efc9f38399ad2)

History

#1 - 2015-11-05 09:18 AM - Giovanni Manghi

- Category changed from Map Tools to Map Canvas

- Priority changed from Normal to Severe/Regression

- Target version set to Future Release - High Priority

- Affected QGIS version changed from 2.12.0 to master

This worked as expected until 2.8.3

Actually in 2.8.3 if selecting outside the boundaries of a certain layer CRS QGIS shown this message

CRS Exception: Selection extends beyond layer's coordinate system

that is not anymore the case in qgis >  2.8.3
#2 - 2015-11-06 01:19 AM - Nyall Dawson

- Status changed from Open to Feedback

Can you give some more detail? I tried with a few multipolygon layers and couldn't reproduce

#3 - 2015-11-09 12:17 AM - Julien Ancelin

- File test_bug_select.sqlite added

Here is a multipolygon layer with a "3943 crs".

if the qgis  project is in crs 3943, no selection problem.

If I reprojects on the fly with "crs 3857" and I'm trying to select all: some multipolygones are not selected

#4 - 2015-11-10 01:15 AM - Giovanni Manghi

- File wb1.dbf.zip added

- Status changed from Feedback to Open

attached another small dataset.

#5 - 2016-01-24 01:13 PM - Nyall Dawson

- Status changed from Open to Feedback

Julien - I get an error opening that dataset

Giovanni - I can't reproduce using your dataset.

#6 - 2016-01-29 02:22 PM - Giovanni Manghi

- Status changed from Feedback to Open

Giovanni - I can't reproduce using your dataset.

open the dataset I attached, enable otf to 2154, try do a selection. Cheers!

#7 - 2016-05-24 10:32 PM - Saber Razmjooei

- Status changed from Open to Feedback

I can't reproduce with the latest master.

#8 - 2016-06-21 05:57 AM - Giovanni Manghi

- Status changed from Feedback to Open
zoom out to ~300.000.000 and try select all features by click and drag.

If you zoom in enough selection seems to work, but not if you zoom out enough.

#9 - 2016-06-22 06:23 AM - Jürgen Fischer

- Status changed from Open to Closed

Fixed in changeset commit:"0a83f182f3e8aea684163096f70efc9f38399ad2".

#10 - 2016-06-22 06:27 AM - Jürgen Fischer

- Resolution set to fixed/implemented

Giovanni Manghi wrote:

zoom out to ~300.000.000 and try select all features by click and drag.

If you zoom in enough selection seems to work, but not if you zoom out enough.

It only worked when the projections were somewhat alike.   The four points of a rectangle around the extent of the layer in EPSG:2154 were transformed to

a polygon in EPSG:3857 that excludes Arabia.  commit:0a83f182 adds 9 points to each rectangle edge and improves it.  Selection for more "stronger"

projections might still "fail" and need more points (e.g. polar and non-polar).

Files

test_bug_select.sqlite 126 KB 2015-11-08 Julien Ancelin

wb1.dbf.zip 24.2 KB 2015-11-10 Giovanni Manghi
